Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/C14b/trcnam_c14b.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/C14b/trcnam_c14b.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/C14b/trcnam_c14b.F90	(revision 2819)
@@ -16,4 +16,5 @@
    USE trc             ! TOP variables
    USE trcsms_c14b     ! C14b specific variable
+   USE iom             ! I/O manager
 
    IMPLICIT NONE
@@ -43,21 +44,11 @@
       INTEGER ::   numnatb
 
-#if defined key_diatrc && ! defined key_iomput
       ! definition of additional diagnostic as a structure
-      INTEGER ::   jl, jn
-      TYPE DIAG
-         CHARACTER(len = 20)  :: snamedia   !: short name
-         CHARACTER(len = 80 ) :: lnamedia   !: long name
-         CHARACTER(len = 20 ) :: unitdia    !: unit
-      END TYPE DIAG
-
-      TYPE(DIAG) , DIMENSION(jp_c14b_2d) :: c14dia2d
-      TYPE(DIAG) , DIMENSION(jp_c14b_3d) :: c14dia3d
-#endif
+      INTEGER :: jl, jn
+      TYPE(DIAG), DIMENSION(jp_c14b_2d) :: c14dia2d
+      TYPE(DIAG), DIMENSION(jp_c14b_3d) :: c14dia3d
       !!
       NAMELIST/namc14date/ ndate_beg_b, nyear_res_b
-#if defined key_diatrc && ! defined key_iomput
-      NAMELIST/namc14dia/nn_writedia, c14dia2d, c14dia3d     ! additional diagnostics
-#endif
+      NAMELIST/namc14dia/  c14dia2d, c14dia3d     ! additional diagnostics
       !!-------------------------------------------------------------------
 
@@ -80,65 +71,56 @@
       IF(lwp) WRITE(numout,*) '    initial year (aa)                  nyear_beg_b = ', nyear_beg_b
       !
-#if defined key_diatrc && ! defined key_iomput
+      IF( .NOT.lk_iomput .AND. ln_diatrc ) THEN
+         !
+         ! Namelist namc14dia
+         ! -------------------
+         DO jl = 1, jp_c14b_2d
+            WRITE(c14dia2d(jl)%sname,'("2D_",I1)') jl                      ! short name
+            WRITE(c14dia2d(jl)%lname,'("2D DIAGNOSTIC NUMBER ",I2)') jl    ! long name
+            c14dia2d(jl)%units = ' '                                       ! units
+         END DO
+         !                                 ! 3D output arrays
+         DO jl = 1, jp_c14b_3d
+            WRITE(c14dia3d(jl)%sname,'("3D_",I1)') jl                      ! short name
+            WRITE(c14dia3d(jl)%lname,'("3D DIAGNOSTIC NUMBER ",I2)') jl    ! long name
+            c14dia3d(jl)%units = ' '                                       ! units
+         END DO
 
-      ! Namelist namc14dia
-      ! -------------------
-      nn_writedia = 10                   ! default values
-
-      DO jl = 1, jp_c14b_2d
-         jn = jp_c14b0_2d + jl - 1
-         WRITE(ctrc2d(jn),'("2D_",I1)') jn                      ! short name
-         WRITE(ctrc2l(jn),'("2D DIAGNOSTIC NUMBER ",I2)') jn    ! long name
-         ctrc2u(jn) = ' '                                       ! units
-      END DO
-      !                                 ! 3D output arrays
-      DO jl = 1, jp_c14b_3d
-         jn = jp_c14b0_3d + jl - 1
-         WRITE(ctrc3d(jn),'("3D_",I1)') jn                      ! short name
-         WRITE(ctrc3l(jn),'("3D DIAGNOSTIC NUMBER ",I2)') jn    ! long name
-         ctrc3u(jn) = ' '                                       ! units
-      END DO
-
-      REWIND( numnatb )               ! read natrtd
-      READ  ( numnatb, namc14dia )
-
-      DO jl = 1, jp_c14b_2d
-         jn = jp_c14b0_2d + jl - 1
-         ctrc2d(jn) = c14dia2d(jl)%snamedia
-         ctrc2l(jn) = c14dia2d(jl)%lnamedia
-         ctrc2u(jn) = c14dia2d(jl)%unitdia
-      END DO
-
-      DO jl = 1, jp_c14b_3d
-         jn = jp_c14b0_3d + jl - 1
-         ctrc3d(jn) = c14dia3d(jl)%snamedia
-         ctrc3l(jn) = c14dia3d(jl)%lnamedia
-         ctrc3u(jn) = c14dia3d(jl)%unitdia
-      END DO
-
-      IF(lwp) THEN                   ! control print
-         WRITE(numout,*)
-         WRITE(numout,*) ' Namelist : natadd'
-         WRITE(numout,*) '    frequency of outputs for additional arrays nn_writedia = ', nn_writedia
-         DO jl = 1, jp_c14b_3d
-            jn = jp_c14b0_3d + jl - 1
-            WRITE(numout,*) '   3d output field No : ',jn
-            WRITE(numout,*) '   short name         : ', TRIM(ctrc3d(jn))
-            WRITE(numout,*) '   long name          : ', TRIM(ctrc3l(jn))
-            WRITE(numout,*) '   unit               : ', TRIM(ctrc3u(jn))
-            WRITE(numout,*) ' '
-         END DO
+         REWIND( numnatb )               ! 
+         READ  ( numnatb, namc14dia )
 
          DO jl = 1, jp_c14b_2d
             jn = jp_c14b0_2d + jl - 1
-            WRITE(numout,*) '   2d output field No : ',jn
-            WRITE(numout,*) '   short name         : ', TRIM(ctrc2d(jn))
-            WRITE(numout,*) '   long name          : ', TRIM(ctrc2l(jn))
-            WRITE(numout,*) '   unit               : ', TRIM(ctrc2u(jn))
+            ctrc2d(jn) = c14dia2d(jl)%sname
+            ctrc2l(jn) = c14dia2d(jl)%lname
+            ctrc2u(jn) = c14dia2d(jl)%units
+         END DO
+
+         DO jl = 1, jp_c14b_3d
+            jn = jp_c14b0_3d + jl - 1
+            ctrc3d(jn) = c14dia3d(jl)%sname
+            ctrc3l(jn) = c14dia3d(jl)%lname
+            ctrc3u(jn) = c14dia3d(jl)%units
+         END DO
+
+         IF(lwp) THEN                   ! control print
+            WRITE(numout,*)
+            WRITE(numout,*) ' Namelist : natadd'
+            DO jl = 1, jp_c14b_3d
+               jn = jp_c14b0_3d + jl - 1
+               WRITE(numout,*) '  3d diag nb : ', jn, '    short name : ', ctrc3d(jn), &
+                 &             '  long name  : ', ctrc3l(jn), '   unit : ', ctrc3u(jn)
+            END DO
             WRITE(numout,*) ' '
-         END DO
+
+            DO jl = 1, jp_c14b_2d
+               jn = jp_c14b0_2d + jl - 1
+               WRITE(numout,*) '  2d diag nb : ', jn, '    short name : ', ctrc2d(jn), &
+                 &             '  long name  : ', ctrc2l(jn), '   unit : ', ctrc2u(jn)
+            END DO
+            WRITE(numout,*) ' '
+         ENDIF
+         !
       ENDIF
-
-#endif
 
    END SUBROUTINE trc_nam_c14b
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/C14b/trcsms_c14b.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/C14b/trcsms_c14b.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/C14b/trcsms_c14b.F90	(revision 2819)
@@ -246,5 +246,4 @@
 #endif
                   &                      * tmask(ji,jj,1) * ( 1. - fr_i(ji,jj) ) / 2.
-
             ! Add the surface flux to the trend
             tra(ji,jj,1,jpc14) = tra(ji,jj,1,jpc14) + qtr_c14(ji,jj) / fse3t(ji,jj,1) 
@@ -253,9 +252,10 @@
             qint_c14(ji,jj) = qint_c14(ji,jj) + qtr_c14(ji,jj) * rdt
 
-# if defined key_diatrc && ! defined key_iomput
-            ! Save 2D diagnostics
-            trc2d(ji,jj,jp_c14b0_2d    ) = qtr_c14 (ji,jj)
-            trc2d(ji,jj,jp_c14b0_2d + 1) = qint_c14(ji,jj)
-# endif 
+            !                                        ! Save 2D diagnostics
+            IF( .NOT.lk_iomput .AND. ln_diatrc ) THEN
+               trc2d(ji,jj,jp_c14b0_2d    ) = qtr_c14 (ji,jj)
+               trc2d(ji,jj,jp_c14b0_2d + 1) = qint_c14(ji,jj)
+            ENDIF 
+            !
          END DO
       END DO
@@ -265,30 +265,28 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-#if ! defined key_degrad
+#if defined key_degrad
+               ztra = trn(ji,jj,jk,jpc14) * ( 1. - EXP( -xlambda * rdt * facvol(ji,jj,jk) ) )
+#else
                ztra = trn(ji,jj,jk,jpc14) * xaccum
-#else
-               ztra = trn(ji,jj,jk,jpc14) * ( 1. - EXP( -xlambda * rdt * facvol(ji,jj,jk) ) )
 #endif
                tra(ji,jj,jk,jpc14) = tra(ji,jj,jk,jpc14) - ztra / rdt
-#if defined key_diatrc
-               ! Save 3D diagnostics
-# if ! defined key_iomput
-               trc3d(ji,jj,jk,jp_c14b0_3d ) = ztra    !  radioactive decay
-# else 
-               zw3d(ji,jj,jk) = ztra    !  radioactive decay
-# endif
-#endif
+               !                                     ! save 3D diag : radioactive decay
+               IF( ln_diatrc ) THEN
+                  IF( lk_iomput ) THEN   ;   zw3d(ji,jj,jk)               = ztra
+                  ELSE                   ;   trc3d(ji,jj,jk,jp_c14b0_3d ) = ztra
+                  ENDIF
+               ENDIF
+               !
             END DO
          END DO
       END DO
 
-#if defined key_diatrc  && defined key_iomput
-      CALL iom_put( "qtrC14b"  , qtr_c14  )
-      CALL iom_put( "qintC14b" , qint_c14 )
-#endif
-#if defined key_diatrc  && defined key_iomput
-      CALL iom_put( "fdecay" , zw3d )
-#endif
-      IF( l_trdtrc )   CALL trd_mod_trc( tra(:,:,:,jpc14), jpc14, jptra_trd_sms, kt )   ! save trends
+      IF( lk_iomput ) THEN
+         CALL iom_put( "qtrC14b"  , qtr_c14  )
+         CALL iom_put( "qintC14b" , qint_c14 )
+         CALL iom_put( "fdecay"   , zw3d     )
+      ENDIF
+
+      IF( l_trdtrc )  CALL trd_mod_trc( tra(:,:,:,jpc14), jpc14, jptra_trd_sms, kt )   ! save trends
 
       IF( wrk_not_released(2, 1) .OR.   &
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/CFC/par_cfc.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/CFC/par_cfc.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/CFC/par_cfc.F90	(revision 2819)
@@ -32,5 +32,5 @@
    !!---------------------------------------------------------------------
    LOGICAL, PUBLIC, PARAMETER ::   lk_cfc     = .TRUE.      !: CFC flag 
-   INTEGER, PUBLIC, PARAMETER ::   jp_cfc     =  2          !: number of passive tracers
+   INTEGER, PUBLIC, PARAMETER ::   jp_cfc     =  1          !: number of passive tracers
    INTEGER, PUBLIC, PARAMETER ::   jp_cfc_2d  =  2          !: additional 2d output arrays ('key_trc_diaadd')
    INTEGER, PUBLIC, PARAMETER ::   jp_cfc_3d  =  0          !: additional 3d output arrays ('key_trc_diaadd')
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/CFC/trcini_cfc.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/CFC/trcini_cfc.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/CFC/trcini_cfc.F90	(revision 2819)
@@ -4,5 +4,5 @@
    !! TOP :   initialisation of the CFC tracers
    !!======================================================================
-   !! History :   2.0  !  2007-12  (C. Ethe, G. Madec) from trcini.cfc.h90
+   !! History :   2.0  !  2007-12  (C. Ethe, G. Madec) 
    !!----------------------------------------------------------------------
 #if defined key_cfc
@@ -43,5 +43,6 @@
       !! ** Method  : - Read the namcfc namelist and check the parameter values
       !!----------------------------------------------------------------------
-      INTEGER  ::  ji, jj, jn, jl, jm, js
+      INTEGER  ::  ji, jj, jn, jl, jm, js, io, ierr
+      INTEGER  ::  iskip = 6   ! number of 1st descriptor lines
       REAL(wp) ::  zyy, zyd
       !!----------------------------------------------------------------------
@@ -51,5 +52,25 @@
       IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~'
 
+
+      IF(lwp) WRITE(numout,*) 'read of formatted file cfc1112atm'
+      
+      CALL ctl_opn( inum, clname, 'OLD', 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE. )
+      REWIND(inum)
+      
+      ! compute the number of year in the file
+      ! file starts in 1931 do jn represent the year in the century
+      jn = 31 
+      DO 
+        READ(inum,'(1x)',END=100) 
+        jn = jn + 1
+      END DO
+ 100  jpyear = jn - 1 - iskip
+      IF ( lwp) WRITE(numout,*) '    ', jpyear ,' years read'
       !                                ! Allocate CFC arrays
+
+      ALLOCATE( p_cfc(jpyear,jphem,2), STAT=ierr )
+      IF( ierr > 0 ) THEN
+         CALL ctl_stop( 'trc_ini_cfc: unable to allocate p_cfc array' )   ;   RETURN
+      ENDIF
       IF( trc_sms_cfc_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'trc_ini_cfc: unable to allocate CFC arrays' )
 
@@ -75,32 +96,17 @@
       ENDIF
 
-
-      !   READ CFC partial pressure atmospheric value :
-      !     p11(year,nt) = PCFC11  in northern (1) and southern (2) hemisphere 
-      !     p12(year,nt) = PCFC12  in northern (1) and southern (2) hemisphere 
-      !--------------------------------------------------------------------
-
-      IF(lwp) WRITE(numout,*) 'read of formatted file cfc1112atm'
-      
-      CALL ctl_opn( inum, clname, 'OLD', 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE. )
       REWIND(inum)
       
-      DO jm = 1, 6        ! Skip over 1st six descriptor lines
+      DO jm = 1, iskip        ! Skip over 1st six descriptor lines
          READ(inum,'(1x)')
       END DO
-   
       ! file starts in 1931 do jn represent the year in the century.jhh
       ! Read file till the end
       jn = 31
-      DO WHILE ( 1 /= 2 )
-         READ(inum,*,END=100) zyy, p_cfc(jn,1,1), p_cfc(jn,1,2), p_cfc(jn,2,1), p_cfc(jn,2,2)
-         IF ( lwp) THEN
-           WRITE(numout,'(f7.2, 4f8.2)' ) &
-            &         zyy, p_cfc(jn,1,1), p_cfc(jn,1,2), p_cfc(jn,2,1), p_cfc(jn,2,2)
-         ENDIF
-         jn = jn + 1
+      DO 
+        READ(inum,*, IOSTAT=io) zyy, p_cfc(jn,1,1), p_cfc(jn,1,2), p_cfc(jn,2,1), p_cfc(jn,2,2)
+        IF( io < 0 ) exit
+        jn = jn + 1
       END DO
- 100  npyear = jn - 1
-      IF ( lwp) WRITE(numout,*) '    ', npyear ,' years read'
 
       p_cfc(32,1:2,1) = 5.e-4      ! modify the values of the first years
@@ -116,5 +122,5 @@
          WRITE(numout,*)
          WRITE(numout,*) ' Year   p11HN    p11HS    p12HN    p12HS '
-         DO jn = 30, 100
+         DO jn = 30, jpyear
             WRITE(numout, '( 1I4, 4F9.2)') jn, p_cfc(jn,1,1), p_cfc(jn,2,1), p_cfc(jn,1,2), p_cfc(jn,2,2)
          END DO
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/CFC/trcnam_cfc.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/CFC/trcnam_cfc.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/CFC/trcnam_cfc.F90	(revision 2819)
@@ -16,4 +16,5 @@
    USE trc             ! TOP variables
    USE trcsms_cfc      ! CFC specific variable
+   USE iom             ! I/O manager
 
    IMPLICIT NONE
@@ -41,21 +42,10 @@
       !! ** input   :   Namelist namcfc
       !!----------------------------------------------------------------------
-      INTEGER ::   numnatc
-#if defined key_diatrc && ! defined key_iomput
-      ! definition of additional diagnostic as a structure
+      INTEGER ::  numnatc
       INTEGER :: jl, jn
-      TYPE DIAG
-         CHARACTER(len = 20)  :: snamedia   !: short name
-         CHARACTER(len = 80 ) :: lnamedia   !: long name
-         CHARACTER(len = 20 ) :: unitdia    !: unit
-      END TYPE DIAG
-
-      TYPE(DIAG) , DIMENSION(jp_cfc_2d) :: cfcdia2d
-#endif
+      TYPE(DIAG), DIMENSION(jp_cfc_2d) :: cfcdia2d
       !!
       NAMELIST/namcfcdate/ ndate_beg, nyear_res
-#if defined key_diatrc && ! defined key_iomput
-      NAMELIST/namcfcdia/nn_writedia, cfcdia2d     ! additional diagnostics
-#endif
+      NAMELIST/namcfcdia/  cfcdia2d     ! additional diagnostics
       !!-------------------------------------------------------------------
 
@@ -78,42 +68,37 @@
       IF(lwp) WRITE(numout,*) '    initial year (aa)                       nyear_beg = ', nyear_beg
       !
-#if defined key_diatrc && ! defined key_iomput
 
-      ! Namelist namcfcdia
-      ! -------------------
-      nn_writedia = 10                   ! default values
+      IF( .NOT.lk_iomput .AND. ln_diatrc ) THEN
+         !
+         ! Namelist namcfcdia
+         ! -------------------
+         DO jl = 1, jp_cfc_2d
+            WRITE(cfcdia2d(jl)%sname,'("2D_",I1)') jl                      ! short name
+            WRITE(cfcdia2d(jl)%lname,'("2D DIAGNOSTIC NUMBER ",I2)') jl    ! long name
+            cfcdia2d(jl)%units = ' '                                       ! units
+         END DO
 
-      DO jl = 1, jp_cfc_2d
-         jn = jp_cfc0_2d + jl - 1 
-         WRITE(ctrc2d(jn),'("2D_",I1)') jn                      ! short name
-         WRITE(ctrc2l(jn),'("2D DIAGNOSTIC NUMBER ",I2)') jn    ! long name
-         ctrc2u(jn) = ' '                                       ! units
-      END DO
+         REWIND( numnatc )               ! read natrtd
+         READ  ( numnatc, namcfcdia )
 
-      REWIND( numnatc )               ! read natrtd
-      READ  ( numnatc, namcfcdia )
-
-      DO jl = 1, jp_cfc_2d
-         jn = jp_cfc0_2d + jl - 1
-         ctrc2d(jn) = cfcdia2d(jl)%snamedia
-         ctrc2l(jn) = cfcdia2d(jl)%lnamedia
-         ctrc2u(jn) = cfcdia2d(jl)%unitdia
-      END DO
-
-
-      IF(lwp) THEN                   ! control print
-         WRITE(numout,*)
-         WRITE(numout,*) ' Namelist : natadd'
-         WRITE(numout,*) '    frequency of outputs for additional arrays nn_writedia = ', nn_writedia
          DO jl = 1, jp_cfc_2d
             jn = jp_cfc0_2d + jl - 1
-            WRITE(numout,*) '   2d output field No : ',jn
-            WRITE(numout,*) '   short name         : ', TRIM(ctrc2d(jn))
-            WRITE(numout,*) '   long name          : ', TRIM(ctrc2l(jn))
-            WRITE(numout,*) '   unit               : ', TRIM(ctrc2u(jn))
+            ctrc2d(jn) = TRIM( cfcdia2d(jl)%sname )
+            ctrc2l(jn) = TRIM( cfcdia2d(jl)%lname )
+            ctrc2u(jn) = TRIM( cfcdia2d(jl)%units )
+         END DO
+
+         IF(lwp) THEN                   ! control print
+            WRITE(numout,*)
+            WRITE(numout,*) ' Namelist : natadd'
+            DO jl = 1, jp_cfc_2d
+               jn = jp_cfc0_2d + jl - 1
+               WRITE(numout,*) '  2d diag nb : ', jn, '    short name : ', ctrc2d(jn), &
+                 &             '  long name  : ', ctrc2l(jn), '   unit : ', ctrc2u(jn)
+            END DO
             WRITE(numout,*) ' '
-         END DO
+         ENDIF
+         !
       ENDIF
-#endif
 
    END SUBROUTINE trc_nam_cfc
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/CFC/trcsms_cfc.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/CFC/trcsms_cfc.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/CFC/trcsms_cfc.F90	(revision 2819)
@@ -28,15 +28,15 @@
    PUBLIC   trc_sms_cfc_alloc   ! called in trcini_cfc.F90
 
-   INTEGER , PUBLIC, PARAMETER ::   jpyear = 150   ! temporal parameter 
    INTEGER , PUBLIC, PARAMETER ::   jphem  =   2   ! parameter for the 2 hemispheres
-   INTEGER , PUBLIC    ::   ndate_beg      ! initial calendar date (aammjj) for CFC
-   INTEGER , PUBLIC    ::   nyear_res      ! restoring time constant (year)
-   INTEGER , PUBLIC    ::   nyear_beg      ! initial year (aa) 
-   INTEGER , PUBLIC    ::   npyear         ! Number of years read in CFC1112 file
+   INTEGER , PUBLIC            ::   jpyear         ! Number of years read in CFC1112 file
+   INTEGER , PUBLIC            ::   ndate_beg      ! initial calendar date (aammjj) for CFC
+   INTEGER , PUBLIC            ::   nyear_res      ! restoring time constant (year)
+   INTEGER , PUBLIC            ::   nyear_beg      ! initial year (aa) 
    
-   REAL(wp), PUBLIC, DIMENSION(jpyear,jphem, 2    )      ::   p_cfc    ! partial hemispheric pressure for CFC
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   p_cfc    ! partial hemispheric pressure for CFC
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   xphem    ! spatial interpolation factor for patm
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   qtr_cfc  ! flux at surface
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   qint_cfc ! cumulative flux 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   patm     ! atmospheric function
 
    REAL(wp), DIMENSION(4,2) ::   soa   ! coefficient for solubility of CFC [mol/l/atm]
@@ -75,6 +75,4 @@
       !!                CFC concentration in pico-mol/m3
       !!----------------------------------------------------------------------
-      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
-      USE wrk_nemo, ONLY:   ztrcfc => wrk_3d_1        ! use for CFC sms trend
       !
       INTEGER, INTENT(in) ::   kt    ! ocean time-step index
@@ -82,5 +80,5 @@
       INTEGER  ::   ji, jj, jn, jl, jm, js
       INTEGER  ::   iyear_beg, iyear_end
-      INTEGER  ::   im1, im2
+      INTEGER  ::   im1, im2, ierr
       REAL(wp) ::   ztap, zdtap        
       REAL(wp) ::   zt1, zt2, zt3, zv2
@@ -90,9 +88,10 @@
       REAL(wp) ::   zca_cfc   ! concentration at equilibrium
       REAL(wp) ::   zak_cfc   ! transfert coefficients
-      REAL(wp), DIMENSION(jphem,jp_cfc) ::   zpatm   ! atmospheric function
-      !!----------------------------------------------------------------------
-      !
-      IF( wrk_in_use(3, 1) ) THEN
-         CALL ctl_stop('trc_sms_cfc: requested workspace array unavailable')   ;   RETURN
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:)  ::   zpatm     ! atmospheric function
+      !!----------------------------------------------------------------------
+      !
+      ALLOCATE( zpatm(jphem,jp_cfc), STAT=ierr )
+      IF( ierr > 0 ) THEN
+         CALL ctl_stop( 'trc_sms_cfc: unable to allocate zpatm array' )   ;   RETURN
       ENDIF
 
@@ -158,5 +157,5 @@
 
                ! Input function  : speed *( conc. at equil - concen at surface )
-               ! trn in pico-mol/l idem qtr; ak in en m/s
+               ! trn in pico-mol/l idem qtr; ak in en m/a
                qtr_cfc(ji,jj,jl) = -zak_cfc * ( trb(ji,jj,1,jn) - zca_cfc )   &
 #if defined key_degrad
@@ -164,5 +163,4 @@
 #endif
                   &                         * tmask(ji,jj,1) * ( 1. - fr_i(ji,jj) )
-
                ! Add the surface flux to the trend
                tra(ji,jj,1,jn) = tra(ji,jj,1,jn) + qtr_cfc(ji,jj,jl) / fse3t(ji,jj,1) 
@@ -176,24 +174,21 @@
       END DO                                                !  end CFC loop  !
       !                                                     !----------------!
-
-#if defined key_diatrc 
-      ! Save diagnostics , just for CFC11
-# if  defined key_iomput
-      CALL iom_put( "qtrCFC11"  , qtr_cfc (:,:,1) )
-      CALL iom_put( "qintCFC11" , qint_cfc(:,:,1) )
-# else
-      trc2d(:,:,jp_cfc0_2d    ) = qtr_cfc (:,:,1)
-      trc2d(:,:,jp_cfc0_2d + 1) = qint_cfc(:,:,1)
-# endif
-#endif
-
+      IF( ln_diatrc ) THEN
+        !
+        IF( lk_iomput ) THEN
+           CALL iom_put( "qtrCFC11"  , qtr_cfc (:,:,1) )
+           CALL iom_put( "qintCFC11" , qint_cfc(:,:,1) )
+        ELSE
+           trc2d(:,:,jp_cfc0_2d    ) = qtr_cfc (:,:,1)
+           trc2d(:,:,jp_cfc0_2d + 1) = qint_cfc(:,:,1)
+        END IF
+        !
+      END IF
+ 
       IF( l_trdtrc ) THEN
           DO jn = jp_cfc0, jp_cfc1
-            ztrcfc(:,:,:) = tra(:,:,:,jn)
-            CALL trd_mod_trc( ztrcfc, jn, jptra_trd_sms, kt )   ! save trends
+            CALL trd_mod_trc( tra(:,:,:,jn), jn, jptra_trd_sms, kt )   ! save trends
           END DO
       END IF
-      !
-      IF( wrk_not_released(3, 1) )   CALL ctl_stop('trc_sms_cfc: failed to release workspace array')
       !
    END SUBROUTINE trc_sms_cfc
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/LOBSTER/par_lobster.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/LOBSTER/par_lobster.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/LOBSTER/par_lobster.F90	(revision 2819)
@@ -19,6 +19,6 @@
    LOGICAL, PUBLIC, PARAMETER ::   lk_lobster     = .TRUE.    !: LOBSTER flag 
    INTEGER, PUBLIC, PARAMETER ::   jp_lobster     =  6        !: number of LOBSTER tracers
-   INTEGER, PUBLIC, PARAMETER ::   jp_lobster_2d  = 19        !: additional 2d output arrays ('key_diatrc')
-   INTEGER, PUBLIC, PARAMETER ::   jp_lobster_3d  =  3        !: additional 3d output arrays ('key_diatrc')
+   INTEGER, PUBLIC, PARAMETER ::   jp_lobster_2d  = 19        !: additional 2d output arrays 
+   INTEGER, PUBLIC, PARAMETER ::   jp_lobster_3d  =  3        !: additional 3d output arrays 
    INTEGER, PUBLIC, PARAMETER ::   jp_lobster_trd = 17       !: number of sms trends for LOBSTER
 
